import { Injectable } from '@angular/core';

@Injectable({
  providedIn: 'root'
})
export class StorageService {

/*
  Localstorageen voi laittaa vain merkkijonomuotoista dataa. Taulukot ja oliot on
  muunnettava merkkijonomuotoon JSON.stringify -metodilla ja takaisin normaaliin 
  muotoon JSON.parse() -metodilla.
  */

  // alustetaan localstorage
  initStorage() {
    if (!localStorage.getItem('calculations')) {
      this.resetStorage();
    }
  }
  resetStorage() {
    // tyhjä taulukko localstorageen
    localStorage.setItem('calculations', JSON.stringify([]));
  }
  // laskutoimituksen lisäys localstorageen
  addCalculation(calc: string) {
	  const calcs = this.getCalculations();
    calcs.push(calc); // uusi alkio taulukkoon, luokan property päivittyy heti
    localStorage.setItem('calculations', JSON.stringify(calcs)); // lisätään uusi taulukko ls:ään
  }
  // laskutoimituksen haku localstoragesta
  getCalculations() {
    this.initStorage(); 
    return JSON.parse(localStorage.getItem('calculations') || '[]');
  }
}




